//##############################################################################
//    	filename:        	uC-Quick_demo_funktionen.c
//
//
//
//##############################################################################
//
//      Author:            	V.SchK
//      Company:        	HS-Ulm
//
//	Revision:        	2.0 (xc8 compatible)
// 	Date:         		November 2014
//     	Assembled using         C18 3.40+ / XC8 1.32+
//
//   	todo	- add comments ;-)
//             	-
//
//##############################################################################

#include "uCQuick/uCQ_2013.h"
#include "LCD/LCD_lib_busy.h"
#include "demo_functions.h"
#ifndef __XC8
    #include <adc.h>
    #include <timers.h>
    #include <usart.h>
    #include <capture.h>

    #pragma udata access acs_scn    // place variables in access RAM
#endif
near union DemoFlags flags;
near unsigned short adc_value;      // fuer AnalogLCD()
near unsigned short capture_value;  // fuer ZeitMess()
near unsigned short old_capture;    // ""
#ifndef __XC8
    #pragma udata                   // let linker place variables (banked RAM)
#endif

//pragma code

//##############################################################################
void TestLEDs(void)
{
//--------------------------------------------------------------------- __init()
    LATBbits.LATB2 = 1;     // LED1 off
    LATBbits.LATB3 = 1;     // LED2 off
    LATBbits.LATB4 = 1;     // LED3 off
    LATBbits.LATB5 = 1;     // LED4 off

    TRISBbits.TRISB2 = 0;   // pin for LED1 -> output
    TRISBbits.TRISB3 = 0;   // pin for LED2 -> output
    TRISBbits.TRISB4 = 0;   // pin for LED3 -> output
    TRISBbits.TRISB5 = 0;   // pin for LED4 -> output

//    LATB  |= 0b00111100;    // binary
//    TRISB &= 0b11000011;    // hexadezimal
//    LATB  |= 0x3C;
//    TRISB &= 0xC3;

//    LED_1_TRI = OUTPUT_PIN;
//    LED_2_TRI = OUTPUT_PIN;
//    LED_3_TRI = OUTPUT_PIN;
//    LED_4_TRI = OUTPUT_PIN;
//----------------------------------------------------------------------- main()
    while(1){
        LATBbits.LATB2 = 1; // LED1 off
        LATBbits.LATB3 = 1; // LED2 off
        LATBbits.LATB4 = 1; // LED3 off
        LATBbits.LATB5 = 1; // LED4 off
        LATBbits.LATB2 = 0; // LED1 on          <- place break-point here
        LATBbits.LATB3 = 0; // LED2 on          then single step
        LATBbits.LATB4 = 0; // LED3 on
        LATBbits.LATB5 = 0; // LED4 on

        LATB = 0b11111111;  // all off binary
        LATB = 0b00000000;  // all on
        LATB = 0xFF;        //   hex
        LATB = 0x00;
        LATB |= 0b00111100; //   mask
        LATB &= 0b11000011;

        LATB |= 0b00000100; // LED1 off
        LATB |= 0b00001000; // LED2 off
        LATB |= 0b00010000; // LED3 off
        LATB |= 0b00100000; // LED4 off

        LATB &= 0b11111011; // LED1 on

        mSET_LED_1_OFF();
        mSET_LED_1_ON();
        mSET_LED_1_OFF();
    }
}

//##############################################################################
void ButtonLEDs(void)
{
//--------------------------------------------------------------------- __init()
    LED_1_TRI = OUTPUT_PIN;
    LED_2_TRI = OUTPUT_PIN;
    LED_3_TRI = OUTPUT_PIN;
    LED_4_TRI = OUTPUT_PIN;
    ENC_BTN_TRI = INPUT_PIN;

//----------------------------------------------------------------------- main()
    while(1){
        if(mGET_ENC_BTN()){
            mSET_LED_1_ON();
            mSET_LED_2_ON();
            mSET_LED_3_ON();
            mSET_LED_4_ON();
        }
        else{
            mSET_LED_1_OFF();
            mSET_LED_2_OFF();
            mSET_LED_3_OFF();
            mSET_LED_4_OFF();
        }
    }
}

//##############################################################################
void ButtonsChangeLEDs(void)
{
//--------------------------------------------------------------------- __init()
    mSET_LED_1_ON();mSET_LED_2_ON();mSET_LED_3_OFF();mSET_LED_4_OFF();
    LED_1_TRI = LED_2_TRI = LED_3_TRI = LED_4_TRI = OUTPUT_PIN;

//----------------------------------------------------------------------- main()
    while(1){
        BTN_L_TRI = INPUT_PIN; WAIT_BTN_CAP();
        if(mGET_BTN_L()){
            while (mGET_BTN_L()){;}
            mTOG_LED_1();
            mTOG_LED_2();
        }
        LED_1_TRI = OUTPUT_PIN;

        BTN_R_TRI = INPUT_PIN; WAIT_BTN_CAP();
        if(mGET_BTN_R()){
            while (mGET_BTN_R()){;}
            mTOG_LED_3();
            mTOG_LED_4();
        }
        LED_3_TRI = OUTPUT_PIN;
    }
}

//##############################################################################
void TTL_ST_toLED(void)
{
//--------------------------------------------------------------------- __init()
    TTL_IN_TRI = INPUT_PIN;
    ST_IN_TRI = INPUT_PIN;      // jumper neben poti !!!
    LED_1_TRI = OUTPUT_PIN;
    LED_2_TRI = OUTPUT_PIN;
    mSET_LED_3_OFF();
    LED_3_TRI = OUTPUT_PIN;
    mSET_LED_4_OFF();
    LED_4_TRI = OUTPUT_PIN;

//----------------------------------------------------------------------- main()
    while(1){               // VDD = 5V
        LED_1 = !TTL_IN;    // ON/OFF ~1.3V
        LED_2 = !ST_IN;     // ON ~2.9V    OFF ~1.4V
    }
}

//##############################################################################
void Blink_Counter(void)
{
    unsigned short time;
//--------------------------------------------------------------------- __init()
    OSCCONbits.IRCF = IRCF_31KHZ;              // 31.25kHz clock
    ENC_BTN_TRI = INPUT_PIN;
    LED_2_TRI = OUTPUT_PIN; // LED button
    LED_3_TRI = OUTPUT_PIN; // LED blink
    mSET_LED_3_ON();

//----------------------------------------------------------------------- main()
    while (1) {
        if(mGET_ENC_BTN())  mSET_LED_2_ON();
        else                mSET_LED_2_OFF();

//        for (time = 0; time < 3906; time++) {;} // wait 1/2 sec. ???
        for (time = 0; time < 300; time++) {;}  // wait 1/2 sec. (better ;-)
          mTOG_LED_3();                         //   then toggle LED
    }
}

//##############################################################################
void Blink_Timer(void)
{
//--------------------------------------------------------------------- __init()
    OSCCONbits.IRCF = IRCF_4MHZ;
    ENC_BTN_TRI = INPUT_PIN;
    LED_2_TRI = OUTPUT_PIN;     // LED button
    LED_3_TRI = OUTPUT_PIN;     // LED blink
    mSET_LED_3_ON();
                                // TIMER_0 setup
    T0CON = 0x82;               // TMR0ON T08BIT T0CS T0SE PSA T0PS2 T0PS1 T0PS0

//----------------------------------------------------------------------- main()
    while (1) {
        if(mGET_ENC_BTN())  mSET_LED_2_ON();
        else                mSET_LED_2_OFF();

        if(INTCONbits.TMR0IF){      // if timer 0 overflow
            mTOG_LED_3();           //   then toggle LED
            INTCONbits.TMR0IF = 0;  //   and clear flag
        }
    }
}

//##############################################################################
void Blink_Interrupt(void)
{
//--------------------------------------------------------------------- __init()

//----------------------------------------------------------------------- main()
    while(1){
        ;
    }
}

//##############################################################################
void Reaktionstest(void)
{
    while(1){;}
}
//##############################################################################
void EncoderLEDs(void)
{
    unsigned char dummy = 0b00000100;    // LEDs RB2..RB5

//--------------------------------------------------------------------- __init()
    LED_1_TRI = OUTPUT_PIN;
    LED_2_TRI = OUTPUT_PIN;
    LED_3_TRI = OUTPUT_PIN;
    LED_4_TRI = OUTPUT_PIN;
    
    ENC_INT_TRI = INPUT_PIN;
    ENC_DIR_TRI = INPUT_PIN;

    mENC_IR_CLR();
    mENC_IR_EN();

    flags.all = 0;

    INTCONbits.GIE = 1;
//----------------------------------------------------------------------- main()
    while(1){
        if(flags.encUp){
            dummy = dummy << 1;
            if(dummy > 0b00100000) dummy = 0b00000100;
            LATB = ~dummy;
            flags.encUp = 0;
        }
        if(flags.encDown){
            dummy = dummy >> 1;
            if(dummy < 0b00000100 ) dummy = 0b00100000;
            LATB = ~dummy;
            flags.encDown = 0;
        }
    }
}

//##############################################################################
void EncoderLCD(void)
{
    short value = 0;

//--------------------------------------------------------------------- __init()
    LCD_Init();
    LCD_ConstTextOut(0,0,"uC-Quick");
    LCD_ConstTextOut(1,0," HS-Ulm ");

    ENC_INT_TRI = INPUT_PIN;    // encoder setup
    ENC_DIR_TRI = INPUT_PIN;

    mENC_IR_CLR();
    mENC_IR_EN();

    flags.all = 0;

    INTCONbits.GIE = 1;
//----------------------------------------------------------------------- main()
    while(1){
        if(flags.encUp){
            value++;
            LCD_ConstTextOut(1,0,"        ");   // delete old value
            LCD_ValueOut(1,1,value);
            flags.encUp = 0;
        }
        if(flags.encDown){
            value--;
            LCD_ConstTextOut(1,0,"        ");   // delete old value
            LCD_ValueOut(1,1,value);
            flags.encDown = 0;
        }
    }
}

//##############################################################################
void AnalogLEDs(void)
{
//--------------------------------------------------------------------- __init()
    LED_1_TRI = OUTPUT_PIN;
    LED_2_TRI = OUTPUT_PIN;
    LED_3_TRI = OUTPUT_PIN;
    LED_4_TRI = OUTPUT_PIN;

    POTI_TRI = INPUT_PIN;
    ANSELAbits.ANSA0 = 1;
    OpenADC(ADC_FOSC_8 & ADC_LEFT_JUST & ADC_12_TAD,
            ADC_POTI & ADC_INT_OFF,
            ADC_TRIG_CCP5 & ADC_REF_VDD_VDD & ADC_REF_VDD_VSS);
//----------------------------------------------------------------------- main()
    while(1){
        ADCON0bits.GO = 1;
        while(ADCON0bits.NOT_DONE){;}
        LATB = ~(ADRESH >> 2);
    }
}

//##############################################################################
void AnalogLCD(void)
{
//--------------------------------------------------------------------- __init()
    SPEAKER_TRI = OUTPUT_PIN;

    ANSELAbits.ANSA0 = 1;
    LATAbits.LATA0 = INPUT_PIN;
    OpenADC(ADC_FOSC_8 & ADC_RIGHT_JUST & ADC_12_TAD,
            ADC_POTI & ADC_INT_ON,
            ADC_TRIG_CCP5 & ADC_REF_VDD_VDD & ADC_REF_VDD_VSS);

    OpenTimer5(TIMER_INT_OFF & T5_16BIT_RW & T5_SOURCE_FOSC_4 &
               T5_PS_1_2 & T5_OSC1EN_OFF & T5_SYNC_EXT_OFF,
               TIMER_GATE_OFF);

    CCPTMRS1bits.C5TSEL  = 2;   // timer <-> ccp module (CCP5 / TMR5)
    CCPR5 = 50000;              // Fosc/4 / prescaler / Fadc = 1MHz /2 /10Hz
    CCP5CONbits.CCP5M = 0b1011; // Compare Mode with Special Event Trigger

    flags.all = 0;

    LCD_Init();
    LCD_ConstTextOut(0,0,"uC-Quick");
    LCD_ConstTextOut(1,0," HS-Ulm ");

    INTCONbits.PEIE = 1;
    INTCONbits.GIE = 1;
//----------------------------------------------------------------------- main()
    while(1){
        if(flags.newADC){
            LCD_ConstTextOut(1,0,"        ");   // delete old value
            LCD_ValueOut(1,1,ADRES);
            flags.newADC = 0;
        }
    }
}

//##############################################################################
void Analog_Out(void)
{
    unsigned char dac_value = 0;

//--------------------------------------------------------------------- __init()
    BTN_L_TRI = INPUT_PIN;
    BTN_R_TRI = INPUT_PIN;
    ENC_BTN_TRI = INPUT_PIN;

    VREFCON0bits.FVRS = 3;      // 4.096 V
    VREFCON0bits.FVREN = 1;
    VREFCON1bits.DACPSS = 2;    // FVR
    VREFCON1bits.DACNSS = 0;    // VSS
    VREFCON1bits.DACOE = 1;
    VREFCON1bits.DACEN = 1;
    TRISAbits.TRISA2 = INPUT_PIN;

//----------------------------------------------------------------------- main()
    while(1){
        dac_value = 0;
        if(mGET_BTN_L()) dac_value +=  4;
        if(mGET_BTN_R()) dac_value +=  8;
        if(mGET_ENC_BTN()) dac_value += 16;

        VREFCON2 = dac_value;
    }
}
//##############################################################################
void Signal_Out(void){

    unsigned char signal_idx = 0;
    unsigned char signal_data[32] = {6, 7, 8, 7, 6, 6, 6, 4,22,31,
                                     0, 3, 6, 6, 8, 9,11,12,11, 8,
                                     6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6};

//--------------------------------------------------------------------- __init()
    VREFCON0bits.FVRS = 3;      // 4.096 V
    VREFCON0bits.FVREN = 1;
    VREFCON1bits.DACPSS = 2;    // FVR
    VREFCON1bits.DACNSS = 0;    // VSS
    VREFCON1bits.DACOE = 1;
    VREFCON1bits.DACEN = 1;
    TRISAbits.TRISA2 = INPUT_PIN;

//----------------------------------------------------------------------- main()
    while(1){
        VREFCON2 = signal_data[signal_idx];
        if(++signal_idx >= 32) signal_idx = 0;
    }
}

//##############################################################################
void Sound_PWM(void){   //PWM   ###TODO -> Lautstaerke !
    unsigned short frequency = 400;

//--------------------------------------------------------------------- __init()
    LCD_Init();
    LCD_ConstTextOut(0,0,"uC-Quick");
    LCD_ConstTextOut(1,0," Sound ");

    ENC_INT_TRI = INPUT_PIN;    // encoder setup
    ENC_DIR_TRI = INPUT_PIN;

    mENC_IR_CLR();
    mENC_IR_EN();

    CCP1CONbits.CCP1M = 0b1100;                             // PWM mode
    CCP1CONbits.P1M = 0;                                    // single
    CCPTMRS0bits.C1TSEL = 0;                                // CCP1-TMR2
    OpenTimer2(TIMER_INT_OFF & T2_PS_1_16 & T2_POST_1_1);
//    OpenTimer2(TIMER_INT_OFF & T2_PS_1_1 & T2_POST_1_1);
    PR2 = 62500 / frequency;                                // 1MHz:16
    CCPR1L = PR2 >> 1;
    SPEAKER_TRI = OUTPUT_PIN;

    flags.all = 0;

    INTCONbits.GIE = 1;
//----------------------------------------------------------------------- main()
    while(1){
        if(flags.encUp){
            if(frequency < 800) {frequency = frequency + 10;}
              else {frequency = frequency + 100;}
            if(frequency > 15600){frequency = 15600;}
            PR2 = (62500 / frequency) -1;             // 1MHz : 16
            CCPR1L = PR2 >> 1;
            LCD_ConstTextOut(1,0,"      ");      // delete old value
            LCD_ValueOut(1,1,frequency);
            flags.encUp = 0;
        }
        if(flags.encDown){
            if(frequency < 800) {frequency = frequency - 10;}
              else {frequency = frequency - 100;}
            if(frequency < 250) {frequency = 250;}
            PR2 = (62500 / frequency)-1;              // 1MHz : 16
            CCPR1L = PR2 >> 1;
            LCD_ConstTextOut(1,0,"      ");      // delete old value
            LCD_ValueOut(1,1,frequency);
            flags.encDown = 0;
        }
    }
}

//##############################################################################
/*
#define F_OSC 4000000
void Sound_Compare(void){
    unsigned short frequency = 400;

//--------------------------------------------------------------------- __init()
    LCD_Init();
    LCD_ConstTextOut(0,0,"uC-Quick");
    LCD_ConstTextOut(1,0," Sound ");

    ENC_INT_TRI = INPUT_PIN;    // encoder setup
    ENC_DIR_TRI = INPUT_PIN;
#ifdef ENCODER_PANASONIC
    mINIT_ENC_EDGE();
#endif
    mENC_IR_CLR();
    mENC_IR_EN();

    CCP1CONbits.CCP1M = 0b1011;                             // Compare sp. event
    CCPTMRS0bits.C1TSEL = 0;                                // CCP1-TMR2
    OpenTimer1(TIMER_INT_OFF & T5_16BIT_RW & T1_SOURCE_FOSC &
               T1_PS_1_1 & T1_OSC1EN_OFF & T1_SYNC_EXT_OFF,
               TIMER_GATE_OFF);
    CCPR1 = (F_OSC/2) / frequency;
    SPEAKER_TRI = OUTPUT_PIN;

    flags.all = 0;

    PIR1bits.CCP1IF = 0;
    PIE1bits.CCP1IE = 1;
    INTCONbits.PEIE = 1;
    INTCONbits.GIE = 1;
//----------------------------------------------------------------------- main()
    while(1){
        if(flags.encUp){
            if(frequency < 800) {frequency = frequency + 10;}
              else {frequency = frequency + 100;}
//            if(frequency > 15600){frequency = 15600;}
            if(frequency > 65000){frequency = 65000;}

            CCPR1 = (F_OSC/2) / frequency;
            LCD_ConstTextOut(1,0,"      Hz ");      // delete old value
            LCD_ValueOut(1,1,frequency);
            flags.encUp = 0;
        }
        if(flags.encDown){
            if(frequency < 800) {frequency = frequency - 10;}
              else {frequency = frequency - 100;}
            if(frequency < 250) {frequency = 250;}
            CCPR1 = (F_OSC/2) / frequency;
            LCD_ConstTextOut(1,0,"      Hz ");      // delete old value
            LCD_ValueOut(1,1,frequency);
            flags.encDown = 0;
        }
    }
}
*/

//##############################################################################
void RS232_TX()
{
    unsigned char character = '0';
//--------------------------------------------------------------------- __init()
    OSCCONbits.IRCF = IRCF_4MHZ;
    TX_TRI = RX_TRI = INPUT_PIN;
    SPBRG1 = 16;                    // 57600 bei 4MHz
    SPBRGH1 = 0;
    TXSTA1bits.BRGH = 1;
    BAUDCON1bits.BRG16 = 1;
    RCSTA1bits.SPEN = 1;
    TXSTAbits.TXEN = 1;
    ENC_BTN_TRI = INPUT_PIN;
//----------------------------------------------------------------------- main()
    while(1){
        if(mGET_ENC_BTN()){
            if(++character > 'z')
                character = '0';
            if(TX_FREE)             // if() <-> while() ???
                TXREG1 = character;
            while(mGET_ENC_BTN()){;}  // ? und ohne diese Zeile ???
        }
    }
}

//##############################################################################
void RS232_RX(void)
{
//--------------------------------------------------------------------- __init()
    OSCCONbits.IRCF = IRCF_4MHZ;
    LED_1_TRI = LED_2_TRI = LED_3_TRI = LED_4_TRI = OUTPUT_PIN;
    TX_TRI = RX_TRI = INPUT_PIN;
    SPBRG1 = 16;                    // 57600 for 4MHz
    SPBRGH1 = 0;
    TXSTA1bits.BRGH = 1;
    BAUDCON1bits.BRG16 = 1;
    RCSTA1bits.SPEN = 1;
    RCSTA1bits.CREN1 = 1;
//----------------------------------------------------------------------- main()
    while(1){
        unsigned char command;
        if(PIR1bits.RC1IF){
            command = RCREG1;
            switch(command){
                case '0': mSET_LED_1_OFF(); mSET_LED_2_OFF();
                          mSET_LED_3_OFF(); mSET_LED_4_OFF(); break;
                case '1': mSET_LED_1_ON(); break;
                case '2': mSET_LED_2_ON(); break;
                case '3': mSET_LED_3_ON(); break;
                case '4': mSET_LED_4_ON(); break;
                default: break;
            }
        }
    }
}

//##############################################################################
void MiniRS232(void)
{
    unsigned char command;
//--------------------------------------------------------------------- __init()
    OSCCONbits.IRCF = IRCF_4MHZ;

    LED_1_TRI = OUTPUT_PIN;
    LED_2_TRI = OUTPUT_PIN;
    LED_3_TRI = OUTPUT_PIN;
    LED_4_TRI = OUTPUT_PIN;
    ENC_BTN_TRI = INPUT_PIN;

#define FOSC        4000000 // in a global header
#define BAUDRATE    19200   // ""
//#define SPBRG_VAL (((FOSC/BAUDRATE)+32)/64)-1   // BRG16=0, BGH=0 !
//#define SPBRG_VAL (((FOSC/BAUDRATE)+8)/16)-1    // BRG16=0, BGH=1 !
#define SPBRG_VAL (((FOSC/BAUDRATE)+2)/4)-1     // BRG16=1, BGH=1 !

    baud1USART(BAUD_IDLE_RX_PIN_STATE_HIGH &
                 BAUD_IDLE_TX_PIN_STATE_HIGH &
                 BAUD_16_BIT_RATE &
                 BAUD_WAKEUP_OFF &
                 BAUD_AUTO_OFF);

    Open1USART( USART_TX_INT_OFF & USART_RX_INT_OFF &
                USART_ASYNCH_MODE & USART_EIGHT_BIT &
                USART_CONT_RX &
                USART_BRGH_HIGH & USART_ADDEN_OFF,
                SPBRG_VAL );
//----------------------------------------------------------------------- main()
    while(1){
        if(DataRdy1USART()){
            command = RCREG1;
            switch(command){
                case '0': mSET_LED_1_OFF(); mSET_LED_2_OFF();
                          mSET_LED_3_OFF(); mSET_LED_4_OFF(); break;
                case '1': mSET_LED_1_OFF(); break;
                case '2': mSET_LED_2_OFF(); break;
                case '3': mSET_LED_3_OFF(); break;
                case '4': mSET_LED_4_OFF(); break;
                case '5': mSET_LED_1_ON(); break;
                case '6': mSET_LED_2_ON(); break;
                case '7': mSET_LED_3_ON(); break;
                case '8': mSET_LED_4_ON(); break;
                case '9': mSET_LED_1_ON(); mSET_LED_2_ON();
                          mSET_LED_3_ON(); mSET_LED_4_ON(); break;
                case '?':
                    BTN_L_TRI = BTN_R_TRI = INPUT_PIN;
                    WAIT_BTN_CAP();
                    command = mGET_BTN_L();
                    command += 2 * mGET_ENC_BTN();
                    command += 4 * mGET_BTN_R();
                    if(command < 10)command += '0';
                    else command += 'A' - 10;
                    TXREG1 = command;
                    LED_1_TRI = LED_2_TRI = LED_3_TRI = LED_4_TRI = OUTPUT_PIN;
                    break;
                default: break;
            }//switch(command){
        }//if(DataRdy1USART()){
    }//while(1){
}

//##############################################################################
void USrangeFinder(void)
{
//--------------------------------------------------------------------- __init()

//----------------------------------------------------------------------- main()
    while(1){
        ;
    }
}

//##############################################################################
void TimeMeasure(void)         // CCP1 => RC2
{
//--------------------------------------------------------------------- __init()
    OSCCONbits.IRCF = IRCF_4MHZ;

    LCD_Init();
    LCD_ConstTextOut(0,0,"ZeitMess");
    LCD_ConstTextOut(1,0,"      us");

    OpenTimer1(TIMER_INT_OFF & T5_16BIT_RW & T1_SOURCE_FOSC_4 &
               T1_PS_1_1 & T1_OSC1EN_OFF & T1_SYNC_EXT_OFF,
               TIMER_GATE_OFF);
    OpenECapture1(CAPTURE_INT_ON & ECAP_EVERY_RISE_EDGE & ECCP_1_SEL_TMR12);

    flags.all = 0;

    INTCONbits.PEIE = 1;
    INTCONbits.GIE = 1;
//----------------------------------------------------------------------- main()
    while(1){
        if(flags.newCapture){
            LCD_ConstTextOut(1,0,"      ");   // delete old value
            LCD_ValueOut(1,0,capture_value);
            flags.newCapture = 0;
        }
    }
}

//######################################################################## Clock
void setHours(unsigned char* hr);
void setMinutes(unsigned char* min);
void setSeconds(unsigned char* sec);
void Clock(unsigned char* hr, unsigned char* min,unsigned char* sec);

typedef enum{
    CM_HR = 0,
    CM_MIN,
    CM_SEC,
    CM_CLOCK
}CLOCKMENU;

void ClockMenu(void)
{
    CLOCKMENU menu;
    unsigned char hours, minutes, seconds;
//--------------------------------------------------------------------- __init()
    OSCCONbits.IRCF = IRCF_2MHZ;

    OpenTimer1(TIMER_INT_OFF & T5_16BIT_RW & T1_SOURCE_FOSC_4 &
               T1_PS_1_8 & T1_OSC1EN_OFF & T1_SYNC_EXT_OFF,
               TIMER_GATE_OFF);

    CCPTMRS0bits.C2TSEL  = 0;       // timer <-> ccp module (CCP2 / TMR1)
    CCPR2 = 62500;                  // Fosc/4 / prescaler  = 500kHz /8
    CCP2CONbits.CCP2M = 0b1011;     // Compare Mode with Special Event Trigger

    flags.all = 0;
    hours = minutes = seconds = 0;
    menu = CM_HR;                   // Begin with adjust hours

    LCD_Init();
    LCD_ConstTextOut(0,0,"hrs. +- ");
    LCD_ConstTextOut(1,0,"00:00:00");

    mENC_IR_CLR();
    mENC_IR_EN();
    INTCONbits.PEIE = 1;
    INTCONbits.GIE = 1;
//----------------------------------------------------------------------- main()
    while(1){
        switch (menu){
            case CM_HR:
                setHours(&hours);
                menu++;
                break;
            case CM_MIN:
                setMinutes(&minutes);
                menu++;
                break;
            case CM_SEC:
                setSeconds(&seconds);
                menu++;
                break;
            case CM_CLOCK:
                mENC_IR_DIS();
                mSEC_IR_EN();
                Clock(&hours,&minutes,&seconds);
                mSEC_IR_DIS();
                mENC_IR_EN();
                menu = CM_HR;
                break;
            default:
                menu = CM_CLOCK;
                break;
        }
    }
}//------------------------------------------------------------------------Clock
void setHours(unsigned char* hr)
{
    LCD_ConstTextOut(0,0,"hrs. +- ");
    ENC_BTN_TRI = INPUT_PIN; WAIT_BTN_CAP();
    while(!mGET_ENC_BTN()){
        ENC_BTN_TRI = OUTPUT_PIN;
        if(flags.encUp){
            if(++*hr >= 24) *hr = 0;
            LCD_ValueOut_00(1,0,*hr,2);
            flags.encUp = 0;
        }
        if(flags.encDown){
            if(--*hr >= 24) *hr = 23;
            LCD_ValueOut_00(1,0,*hr,2);
            flags.encDown = 0;
        }
        ENC_BTN_TRI = INPUT_PIN; WAIT_BTN_CAP();
    }
    while(mGET_ENC_BTN()){;}
    ENC_BTN_TRI = OUTPUT_PIN;
}//------------------------------------------------------------------------Clock
void setMinutes(unsigned char* min)
{
    LCD_ConstTextOut(0,0,"min. +- ");
    ENC_BTN_TRI = INPUT_PIN; WAIT_BTN_CAP();
    while(!mGET_ENC_BTN()){
        ENC_BTN_TRI = OUTPUT_PIN;
        if(flags.encUp){
            if(++*min >= 59) *min = 0;
            LCD_ValueOut_00(1,3,*min,2);
            flags.encUp = 0;
        }
        if(flags.encDown){
            if(--*min >= 59) *min = 59;
            LCD_ValueOut_00(1,3,*min,2);
            flags.encDown = 0;
        }
        ENC_BTN_TRI = INPUT_PIN; WAIT_BTN_CAP();
    }
    while(mGET_ENC_BTN()){;}
    ENC_BTN_TRI = OUTPUT_PIN;
}//------------------------------------------------------------------------Clock
void setSeconds(unsigned char* sec)
{
    LCD_ConstTextOut(0,0,"sec. +- ");
    ENC_BTN_TRI = INPUT_PIN; WAIT_BTN_CAP();
    while(!mGET_ENC_BTN()){
        ENC_BTN_TRI = OUTPUT_PIN;
        if(flags.encUp){
            if(++*sec >= 59) *sec = 0;
            LCD_ValueOut_00(1,6,*sec,2);
            flags.encUp = 0;
        }
        if(flags.encDown){
            if(--*sec >= 59) *sec = 59;
            LCD_ValueOut_00(1,6,*sec,2);
            flags.encDown = 0;
        }
        ENC_BTN_TRI = INPUT_PIN; WAIT_BTN_CAP();
    }
    while(mGET_ENC_BTN()){;}
    ENC_BTN_TRI = OUTPUT_PIN;
}//------------------------------------------------------------------------Clock
void Clock(unsigned char* hr, unsigned char* min, unsigned char* sec)
{
    LCD_ConstTextOut(0, 0, "Time:   ");
    ENC_BTN_TRI = INPUT_PIN; WAIT_BTN_CAP();
    while (!mGET_ENC_BTN()) {
        ENC_BTN_TRI = OUTPUT_PIN;
        if (flags.newSec) {
            if (++*sec >= 60) {
                *sec = 0;
                if (++*min >= 60) {
                    *min = 0;
                    if (++*hr >= 24) {
                        *hr = 0;
                    }
                    LCD_ValueOut_00(1, 0, *hr, 2);
                }
                LCD_ValueOut_00(1, 3, *min, 2);
            }
            LCD_ValueOut_00(1, 6, *sec, 2);
            flags.newSec = 0;
        }
        ENC_BTN_TRI = INPUT_PIN; WAIT_BTN_CAP();
    }
    while (mGET_ENC_BTN()) {;}
    ENC_BTN_TRI = OUTPUT_PIN;
}//--------------------------------------------------------------------end Clock

void BoardTest(void)
{
    unsigned short frequency = 250;

//--------------------------------------------------------------------- __init()
    OSCCONbits.IRCF = IRCF_4MHZ;

    LCD_Init();
    LCD_ConstTextOut(0,0,"MCON-LAB");
    LCD_ConstTextOut(1,0," HS-ULM ");

    LED_1_TRI = OUTPUT_PIN;
    LED_2_TRI = OUTPUT_PIN;
    LED_3_TRI = OUTPUT_PIN;
    LED_4_TRI = OUTPUT_PIN;

    ENC_INT_TRI = INPUT_PIN;    // encoder setup
    ENC_DIR_TRI = INPUT_PIN;

    mENC_IR_CLR();
    mENC_IR_EN();

//PWM --------------------------------------------------------------------------
    CCP1CONbits.CCP1M = 0b1100;                             // PWM mode
    CCP1CONbits.P1M = 0;                                    // single
    CCPTMRS0bits.C1TSEL = 0;                                // CCP1-TMR2
    OpenTimer2(TIMER_INT_OFF & T2_PS_1_16 & T2_POST_1_1);
//    OpenTimer2(TIMER_INT_OFF & T2_PS_1_1 & T2_POST_1_1);
    PR2 = 62500 / frequency;                                // 1MHz:16
    CCPR1L = PR2 >> 1;
    SPEAKER_TRI = OUTPUT_PIN;

//ADC --------------------------------------------------------------------------
    ANSELAbits.ANSA0 = 1;
    LATAbits.LATA0 = INPUT_PIN;
    OpenADC(ADC_FOSC_8 & ADC_RIGHT_JUST & ADC_12_TAD,
            ADC_POTI & ADC_INT_ON,
            ADC_TRIG_CCP5 & ADC_REF_VDD_VDD & ADC_REF_VDD_VSS);

    OpenTimer5(TIMER_INT_OFF & T5_16BIT_RW & T5_SOURCE_FOSC_4 &
               T5_PS_1_2 & T5_OSC1EN_OFF & T5_SYNC_EXT_OFF,
               TIMER_GATE_OFF);

    CCPTMRS1bits.C5TSEL  = 2;   // timer <-> ccp module (CCP5 / TMR5)
    CCPR5 = 50000;              // Fosc/4 / prescaler / Fadc = 1MHz /2 /10Hz
    CCP5CONbits.CCP5M = 0b1011; // Compare Mode with Special Event Trigger

//USART ------------------------------------------------------------------------
#define FOSC        4000000 // in a global header
#define BAUDRATE    19200   // ""
//#define SPBRG_VAL (((FOSC/BAUDRATE)+32)/64)-1   // BRG16=0, BGH=0 !
//#define SPBRG_VAL (((FOSC/BAUDRATE)+8)/16)-1    // BRG16=0, BGH=1 !
#define SPBRG_VAL (((FOSC/BAUDRATE)+2)/4)-1     // BRG16=1, BGH=1 !

    baud1USART(BAUD_IDLE_RX_PIN_STATE_HIGH &
                 BAUD_IDLE_TX_PIN_STATE_HIGH &
                 BAUD_16_BIT_RATE &
                 BAUD_WAKEUP_OFF &
                 BAUD_AUTO_OFF);

    Open1USART( USART_TX_INT_OFF & USART_RX_INT_OFF &
                USART_ASYNCH_MODE & USART_EIGHT_BIT &
                USART_CONT_RX &
                USART_BRGH_HIGH & USART_ADDEN_OFF,
                SPBRG_VAL );

    while(!mGET_ENC_BTN()){
        if(DataRdy1USART()){TXREG1 = RCREG1 + 1;}
    }
    LCD_ConstTextOut(0,0,"ADC ??? ");
    LCD_ConstTextOut(1,0,"PWM ??? ");

    flags.all = 0;
    INTCONbits.PEIE = 1;
    INTCONbits.GIE = 1;

//----------------------------------------------------------------------- main()
    while(1) {
    //----------------------------------------------------- check buttons & LEDs
        while (mGET_ENC_BTN()) {
            BTN_L_TRI = INPUT_PIN; WAIT_BTN_CAP();
            if (mGET_BTN_L()) {
                while (mGET_BTN_L()) {;}
                mTOG_LED_1();
                mTOG_LED_2();
            }
            LED_1_TRI = OUTPUT_PIN;

            BTN_R_TRI = INPUT_PIN; WAIT_BTN_CAP();
            if (mGET_BTN_R()) {
                while (mGET_BTN_R()) {;}
                mTOG_LED_3();
                mTOG_LED_4();
            }
            LED_3_TRI = OUTPUT_PIN;
        }
    //------------------------------------------------------ check encoder & PWM
        if(flags.encUp){
            if(frequency < 800) {frequency = frequency + 10;}
              else {frequency = frequency + 100;}
            if(frequency > 15600){frequency = 15600;}
            PR2 = (62500 / frequency) -1;   // 1MHz : 16
            CCPR1L = PR2 >> 1;
            LCD_ConstTextOut(1,4,"    ");   // delete old value
            LCD_ValueOut(1,4,frequency);
            flags.encUp = 0;
        }
        if(flags.encDown){
            if(frequency < 800) {frequency = frequency - 10;}
              else {frequency = frequency - 100;}
            if(frequency < 250) {frequency = 250;}
            PR2 = (62500 / frequency)-1;    // 1MHz : 16
            CCPR1L = PR2 >> 1;
            LCD_ConstTextOut(1,4,"    ");   // delete old value
            LCD_ValueOut(1,4,frequency);
            flags.encDown = 0;
        }
    //---------------------------------------------------------------- check ADC
        if(flags.newADC){
            LCD_ConstTextOut(0,4,"    ");   // delete old value
            LCD_ValueOut(0,4,ADRES);
            flags.newADC = 0;
        }
    //-------------------------------------------------------------- check USART
        if(DataRdy1USART()){
            TXREG1 = RCREG1 + 1;            // 'a' -> 'b' ...
        }
    }
}

//##############################################################################
